/**
 * @file 	SimpleFunction.java
 * 
 * @date 	Aug 16, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.apps;

import java.util.ArrayList;
import java.util.List;

import ca.mcgill.rl.util.EuclideanLocation;
import ca.mcgill.rl.util.MultiInterval;
import ca.mcgill.rl.util.RealValuedFunction;
import ca.mcgill.rl.util.State;
import ca.mcgill.rl.util.StateSpace;

/**
 *
 */
public class SimpleFunction implements RealValuedFunction
{
    /**
     * TODO:
     * Comment for <code>stateSpace</code>
     */
    private MultiInterval stateSpace;
    
    /**
     * 
     */
    public SimpleFunction()
    {
        List lowerBounds = new ArrayList(2);
        lowerBounds.add(new Double(0));
        lowerBounds.add(new Double(0));
        List upperBounds = new ArrayList(2);
        upperBounds.add(new Double(1));
        upperBounds.add(new Double(1));
        stateSpace = new MultiInterval(lowerBounds, upperBounds);
    }

    /**
     * @return
     */
    public StateSpace getStateSpace()
    {
        return stateSpace;
    }

    /**
     * @param randomState
     * @return
     */
    public double evaluateAt(State state)
    {
        EuclideanLocation location = (EuclideanLocation) state;
        double x = location.getCoordinate(0);
        double y = location.getCoordinate(1);
        return (x*x + y*y);
    }

    /**
     * 
     */
    public void setStateSpace(StateSpace stateSpace)
    {
        this.stateSpace = (MultiInterval) stateSpace;
    }

}
