/**
 * @file 	DiscreteAction.java
 * 
 * @date 	Aug 8, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.ndp;

/**
 * An action from a NDP problem with a finite set of actions.
 */
public class DiscreteAction implements Action
{
    /**
     * @param arg0
     * @return
     */
    public boolean equals(Object object)
    {
        if (object instanceof DiscreteAction)
        {
            DiscreteAction action2 = (DiscreteAction) object;
            if (action2.getValue() == this.getValue())
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        return super.equals(object);
    }
    
    
    
    /**
     * @return
     */
    public int hashCode()
    {
        // TODO Auto-generated method stub
        return value;
    }
    /**
     * The id of this action.
     */
    private int value;
    
    /**
     * Create an action with the given identifier (id).
     * 
     * @param value This action's identifier.
     */
    public DiscreteAction(int value)
    {
        this.value = value;
    }
    
    /**
     * Returns the id of this action.
     * 
     * @return The id of this action.
     */
    public int getValue()
    {
        return value;
    }
}
