/**
 * @file 	EpsilonGreedyCostToGoPolicy.java
 * 
 * @date 	Aug 17, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.ndp;

import ca.mcgill.rl.util.Configurable;
import ca.mcgill.rl.util.TypedProperties;

/**
 *
 */
public class EpsilonGreedyCostToGoPolicy extends EpsilonGreedyPolicy implements
        ImplicitCostToGoPolicy
{
    /**
     * TODO:
     * Comment for <code>approximator</code>
     */
    private Approximator approximator;
    
    /**
     * TODO:
     * Comment for <code>transitionProbabilities</code>
     */
    private TransitionProbabilities transitionProbabilities;
    
    /**
     * TODO:
     * Comment for <code>propertyPrefix</code>
     */
    private static String propertyPrefix = "EpsilonGreedyCostToGoPolicy.";    

    /**
     * @param approximator
     */
    public void setApproximator(Approximator approximator)
    {
        this.approximator = approximator;
    }

    /**
     * @param transitionProbabilities
     */
    public void setTransitionProbabilities(
            TransitionProbabilities transitionProbabilities)
    {
        this.transitionProbabilities = transitionProbabilities;
    }
    
    /**
     * @param properties
     */
    public void configure(TypedProperties properties)
    {
        epsilon = properties.getPropertyAsDouble(propertyPrefix + "epsilon");
        enclosedPolicy = (Policy) properties.getPropertyAsObject(propertyPrefix + "enclosedPolicy");
        ((ImplicitCostToGoPolicy) enclosedPolicy).setApproximator(approximator);
        ((ImplicitCostToGoPolicy) enclosedPolicy).setTransitionProbabilities(transitionProbabilities);
        if (enclosedPolicy instanceof Configurable)
        {
            ((Configurable) enclosedPolicy).configure(properties);
        }
    }
}
