/**
 * @file 	EpsilonGreedyHeuristicPolicy.java
 * 
 * @date 	Aug 18, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.ndp;

import ca.mcgill.rl.util.Configurable;
import ca.mcgill.rl.util.TypedProperties;

/**
 *
 */
public class EpsilonGreedyHeuristicPolicy extends EpsilonGreedyPolicy implements
        HeuristicPolicy
{
    /**
     * TODO:
     * Comment for <code>propertyPrefix</code>
     */
    private static String propertyPrefix = "EpsilonGreedyHeuristicPolicy.";
    
    /**
     * TODO:
     * Comment for <code>environment</code>
     */
    private EnvironmentSimulator environment;
    
    /**
     * @param environment
     */
    public void setEnvironment(EnvironmentSimulator environment)
    {
        this.environment = environment;
    }

    /**
     * @param properties
     */
    public void configure(TypedProperties properties)
    {
        epsilon = properties.getPropertyAsDouble(propertyPrefix + "epsilon");
        enclosedPolicy = (Policy) properties.getPropertyAsObject(propertyPrefix + "enclosedPolicy");
        ((HeuristicPolicy) enclosedPolicy).setEnvironment(environment);
        if (enclosedPolicy instanceof Configurable)
        {
            ((Configurable) enclosedPolicy).configure(properties);
        }
    }
}
