/**
 * @file 	EpsilonGreedyPolicy.java
 * 
 * @date 	Aug 17, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.ndp;

import java.util.List;
import java.util.Random;

import ca.mcgill.rl.util.Configurable;
import ca.mcgill.rl.util.State;
import ca.mcgill.rl.util.TypedProperties;

/**
 *
 */
public class EpsilonGreedyPolicy implements Policy, Configurable
{
    /**
     * TODO:
     * Comment for <code>enclosedPolicy</code>
     */
    protected Policy enclosedPolicy;
    
    /**
     * TODO:
     * Comment for <code>randomNumberGenerator</code>
     */
    private Random randomNumberGenerator = new Random(System.currentTimeMillis());
    
    /**
     * TODO:
     * Comment for <code>propertyPrefix</code>
     */
    private static String propertyPrefix = "EpsilonGreedyPolicy.";    
    
    /**
     * TODO:
     * Comment for <code>epsilon</code>
     */
    protected double epsilon;    

    /**
     * @param currentState
     * @param possibleActions
     * @return
     */
    public Action selectAction(State currentState, List possibleActions)
    {
        if (randomNumberGenerator.nextDouble() < epsilon)
        {
            return (Action) possibleActions.get(randomNumberGenerator.nextInt(possibleActions.size()));
        }
        else
        {
            return enclosedPolicy.selectAction(currentState, possibleActions);
        }
    } 
    
    /**
     * @param properties
     */
    public void configure(TypedProperties properties)
    {
        epsilon = properties.getPropertyAsDouble(propertyPrefix + "epsilon");
        enclosedPolicy = (Policy) properties.getPropertyAsObject(propertyPrefix + "enclosedPolicy");
        if (enclosedPolicy instanceof Configurable)
        {
            ((Configurable) enclosedPolicy).configure(properties);
        }
    }    
}
