/**
 * @file 	EpsilonGreedyStateActionPolicy.java
 * 
 * @date 	Aug 12, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.ndp;

import ca.mcgill.rl.util.Configurable;
import ca.mcgill.rl.util.TypedProperties;

/**
 *
 */
public class EpsilonGreedyStateActionPolicy 	extends EpsilonGreedyPolicy 
											implements ImplicitStateActionPolicy
{   
    /**
     * TODO:
     * Comment for <code>stateActionApproximator</code>
     */
    private StateActionApproximator stateActionApproximator;
    
    /**
     * TODO:
     * Comment for <code>propertyPrefix</code>
     */
    private static String propertyPrefix = "EpsilonGreedyStateActionPolicy.";

    /**
     * @param stateActionApproximator
     */
    public void setStateActionApproximator(StateActionApproximator stateActionApproximator)
    {
        this.stateActionApproximator = stateActionApproximator;
    }

    /**
     * @param properties
     */
    public void configure(TypedProperties properties)
    {
        epsilon = properties.getPropertyAsDouble(propertyPrefix + "epsilon");
        enclosedPolicy = (Policy) properties.getPropertyAsObject(propertyPrefix + "enclosedPolicy");
        ((ImplicitStateActionPolicy) enclosedPolicy).setStateActionApproximator(stateActionApproximator);
        if (enclosedPolicy instanceof Configurable)
        {
            ((Configurable) enclosedPolicy).configure(properties);
        }
    }

}
