/**
 * @file 	MountainCarEnvironment.java
 * 
 * @date 	Aug 4, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.ndp;

import java.util.List;

import ca.mcgill.rl.util.State;

/** 
 * A policy is a map from the set of state to the set of actions of an NDP problem.
 */
public interface Policy
{
    /**
     * Select an action from a set of possibleActions given the state.
     * 
     * @param currentState The state from which the decision is taken
     * @param possibleActions The actions that are allowed from the currentState
     * @return The selected action
     */
    public Action selectAction(State currentState, List possibleActions);
}
