/**
 * @file 	HardLocationManager.java
 * 
 * @date 	Aug 4, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.sdm;

/**
 * An hardLocation manager in a SDM is responsible of dynamic allocation of hard
 * locations.
 */
public interface HardLocationManager
{

    /**
     * Reorganize (add or delete hard locations) in the given neighborhood.
     * 
     * @param neighborhood
     */
    void reorganize(ActiveLocations neighborhood);

    /**
     * Called by SDM at initialization, should distribute (optionally) some hard
     * locations in the space.
     */
    void initialInsertion();

    /**
     * @param architecture
     */
    void setSDM(EuclideanSDMArchitecture architecture);

}
