/**
 * @file 	HashSupport.java
 * 
 * @date 	Aug 4, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.sdm;

import ca.mcgill.rl.util.AffineVector;
import ca.mcgill.rl.util.EuclideanLocation;

/**
 *
 */
public interface HardLocationSupport
{

    /**
     * @param parametersIncrement
     */
    public void updateParameters(AffineVector parametersIncrement);

    /**
     * @param state
     * @return
     */
    public ActiveLocations getNeighborhood(EuclideanLocation state);

    /**
     * @return
     */
    public int getNumberOfParameters();

    /**
     * @param newHardLocation
     */
    public void addHardLocation(HardLocation newHardLocation);
    
    /**
     * @param hardLocation
     */
    public void removeHardLocation(HardLocation hardLocation);
    
    /**
     * @param hardLocation
     * @return
     */
    public double getWeight(HardLocation hardLocation);
    
    /**
     * @param hardLocation
     * @param weight
     */
    public void setWeight(HardLocation hardLocation, double weight);

    /**
     * @param architecture
     */
    public void setSDM(EuclideanSDMArchitecture architecture);
}
