/**
 * @file 	DiscreteMeasure.java
 * 
 * @date 	Aug 16, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.util;

import java.util.List;


/**
 *
 */
public class DiscreteMeasure implements ProbabilityMeasure
{
    /**
     * TODO:
     * Comment for <code>stateSpace</code>
     */
    private StateSpace stateSpace;
    
    /**
     * TODO:
     * Comment for <code>probabilities</code>
     */
    private List probabilities;
    
    /**
     * TODO:
     * Comment for <code>states</code>
     */
    private List states;
    
    /**
     * @param nonZeroProbabilityStates
     * @param probabilities
     */
    public DiscreteMeasure(List nonZeroProbabilityStates, List probabilities)
    {
        this.states = nonZeroProbabilityStates;
        this.probabilities = probabilities;
    }
    
    public List getNonZeroProbabilityStates()
    {
        return states;
    }

    /**
     * @param function
     * @return
     */
    public double integrate(RealValuedFunction function)
    {
        double partialSum = 0;
        for (int i = 0; i < states.size(); i++)
        {
            partialSum = partialSum + function.evaluateAt((State) states.get(i)) * ((Double) probabilities.get(i)).doubleValue();
        }
        return partialSum;
    }

    /**
     * @param stateSpace
     */
    public void setStateSpace(StateSpace stateSpace)
    {
        this.stateSpace = stateSpace;
    }

    /**
     * @return
     */
    public StateSpace getStateSpace()
    {
        return stateSpace;
    }

}
