/**
 * @file 	MultiInterval.java
 * 
 * @date 	Aug 9, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.util;

import java.util.List;
import java.util.Random;


/**
 *
 */
public class MultiInterval implements StateSpace
{
    /**
     * TODO:
     * Comment for <code>upperBounds</code>
     */
    private List upperBounds;
    
    /**
     * TODO:
     * Comment for <code>lowerBounds</code>
     */
    private List lowerBounds;
    
    /**
     * TODO:
     * Comment for <code>randomNumberGenerator</code>
     */
    private Random randomNumberGenerator = new Random(System.currentTimeMillis());
    
    /**
     * @param lowerBounds
     * @param upperBounds
     */
    public MultiInterval(List lowerBounds, List upperBounds)
    {
        this.upperBounds = upperBounds;
        this.lowerBounds = lowerBounds;
    }

    /**
     * @return
     */
    public int getDimensionality()
    {
        return upperBounds.size();
    }

    /**
     * @param i
     * @return
     */
    public double getLowerBound(int i)
    {
        return ((Double) lowerBounds.get(i)).doubleValue();
    }
    
    /**
     * @param i
     * @return
     */
    public double getUpperBound(int i)
    {
        return ((Double) upperBounds.get(i)).doubleValue();
    }

    /**
     * @return
     */
    public State getRandomState()
    {
        EuclideanLocation state = new EuclideanLocation(upperBounds.size());
        for (int i = 0; i < upperBounds.size(); i++)
        {
            double currentUpperBound = ((Double) upperBounds.get(i)).doubleValue();
            double currentLowerBound = ((Double) lowerBounds.get(i)).doubleValue();
            double currentCoordinate = randomNumberGenerator.nextDouble() * (currentUpperBound - currentLowerBound) + currentLowerBound;
            state.setCoordinate(i, currentCoordinate);
        }
        return state;
    }
}
