/**
 * @file 	TypedProperties.java
 * 
 * @date 	Aug 15, 2004
 * @author 	Alexandre Bouchard
 */

package ca.mcgill.rl.util;

import java.util.Properties;

/**
 *
 */
public class TypedProperties extends Properties
{
    /**
     * 
     */
    public TypedProperties()
    {
        super();
        // TODO Auto-generated constructor stub
    }
    /**
     * @param arg0
     */
    public TypedProperties(Properties arg0)
    {
        super(arg0);
        // TODO Auto-generated constructor stub
    }
    
    /**
     * @param key
     * @return
     */
    public int getPropertyAsInt(String key)
    {
        try
        {
            return Integer.valueOf(getProperty(key)).intValue();
        }
        catch (NullPointerException npe)
        {
            throw new RuntimeException("Property " + key + " missing in the property file.");
        }
        catch (NumberFormatException nfe)
        {
            throw new RuntimeException("Property " + key + " should be an integer.");
        }
    }
    
    /**
     * @param key
     * @return
     */
    public double getPropertyAsDouble(String key)
    {
        try
        {        
            return Double.valueOf(getProperty(key)).doubleValue();
        }
        catch (NullPointerException npe)
        {
            throw new RuntimeException("Property " + key + " missing in the property file.");
        }
        catch (NumberFormatException nfe)
        {
            throw new RuntimeException("Property " + key + " should be a double.");
        }            
    }
    
    /**
     * @param key
     * @return
     */
    public Object getPropertyAsObject(String key)
    {
        Object object = null;
		try 
		{
		    String className = getProperty(key);
			Class classDefinition = Class.forName(className);
			object = classDefinition.newInstance();
		}
		catch (InstantiationException e) 
		{
		    System.out.println("Instantiation error with class " + key);
		} 
		catch (IllegalAccessException e) 
		{
		    System.out.println("The type " + key + " should have an empty constructor to be used by Configurable.configure()");
		}
		catch (ClassNotFoundException e) 
		{
		    System.out.println("Property " + key + " should be a fully qualified java class.");
		}
		return object;
    }
    
    /**
     * @param string
     * @param i
     * @return
     */
    public int getPropertyAsInt(String key, int defaultValue)
    {
        try
        {
            String value = getProperty(key);
            if (value == null)
            {
                return defaultValue;
            }
            else
            {
                return Integer.valueOf(value).intValue();
            }
        }
        catch (NumberFormatException nfe)
        {
            throw new RuntimeException("Property " + key + " should be an integer.");
        }
    }
    
    /**
     * @param string
     * @param i
     * @return
     */
    public double getPropertyAsDouble(String key, double defaultValue)
    {
        try
        {
            String value = getProperty(key);
            if (value == null)
            {
                return defaultValue;
            }
            else
            {
                return Double.valueOf(value).doubleValue();
            }
        }
        catch (NumberFormatException nfe)
        {
            throw new RuntimeException("Property " + key + " should be an integer.");
        }
    }    
}
